Core Features

Advanced Features

JavaScript Data GridRow Styles

Version 36.2.0

Row customisation can be achieved in the following ways:

  • Row Style: Providing a CSS style for the rows. Applied individually to each element.
  • Row Class: Providing a CSS class for the rows. Not removed on data refresh.
  • Row Class Rules: Providing rules for applying CSS classes. These styles are dynamic and applied in batches.

We recommend Row Class Rules for most use cases. See Refresh of Styles for more details.

When spanning rows, the row is not a visual component, and so the cells should be styled instead.

Each of these approaches are presented in the following sections.

Row Style Copy Link

You can add CSS styles to each row in the following ways:

rowStyleCopy Link
RowStyle
The style properties to apply to all rows. Set to an object of key (style names) and values (style values).
getRowStyleCopy Link
GetRowStyle
Callback version of property rowStyle to set style for each row individually. Function should return an object of CSS values or undefined for no styles.
const gridOptions = {
    // set background colour on every row, this is probably bad, should be using CSS classes
    rowStyle: { background: 'black' },

    // set background colour on even rows again, this looks bad, should be using CSS classes
    getRowStyle: params => {
        if (params.node.rowIndex % 2 === 0) {
            return { background: 'red' };
        }
    },

    // other grid options ...
}

If your data is static, use row classes to apply styles for better performance.

Row Class Copy Link

You can add CSS classes to each row in the following ways:

rowClassCopy Link
string | string[]
CSS class(es) for all rows. Provide either a string (class name) or array of strings (array of class names).
getRowClassCopy Link
GetRowClass
Callback version of property rowClass to set class(es) for each row individually. Function should return either a string (class name), array of strings (array of class names) or undefined for no class.
const gridOptions = {
    // all rows assigned CSS class 'my-green-class'
    rowClass: 'my-green-class',

    // all even rows assigned 'my-shaded-effect'
    getRowClass: params => {
        if (params.node.rowIndex % 2 === 0) {
            return 'my-shaded-effect';
        }
    },

    // other grid options ...
}

Row Class Rules Copy Link

You can define rules which can be applied to include certain CSS classes via the grid option rowClassRules. These rules are provided as a map where the keys are class names and the values are expressions that if evaluated to true, the class gets used. The expression can either be a function, or a string which is treated as a shorthand for a function by the grid.

rowClassRulesCopy Link
RowClassRules
Rules which can be applied to include certain CSS classes.

The following snippet shows rowClassRules that use functions and the value from the year column:

const gridOptions = {
    rowClassRules: {
        // apply green to 2008
        'rag-green-outer': (params) => { return params.data.year === 2008; },

        // apply amber 2004
        'rag-amber-outer': (params) => { return params.data.year === 2004; },

        // apply red to 2000
        'rag-red-outer': (params) => { return params.data.year === 2000; }
    },

    // other grid options ...
}

Row Style/Class Functions Copy Link

All rowStyle, rowClass and rowClassRules functions take a RowClassParams params object.

Properties available on the RowClassParams<TData = any, TContext = any> interface.

The data associated with this row from rowData. Data is undefined for row groups.
The RowNode associated with this row
rowIndexCopy Link
number
The index of the row
The grid api.
Application context as set on gridOptions.context.

As an alternative, you can also provide shorthands of the functions using an expression. An expression is evaluated by the grid by executing the string as if it were a Javascript expression. The expression has the following attributes available to it (mapping the attributes of the equivalent params object):

  • ctx: maps context
  • node: maps node
  • data: maps data
  • rowIndex: maps rowIndex
  • api: maps the grid api

The following snippet shows rowClassRules applying classes to rows using expressions on an age column value:

const gridOptions = {
    rowClassRules: {
        'rag-green': 'data.age < 20',
        'rag-amber': 'data.age >= 20 && data.age < 25',
        'rag-red': 'data.age >= 25',
    },

    // other grid options ...
}

Refresh of Styles Copy Link

If you refresh a row, or a cell is updated due to editing, the rowStyle, rowClass and rowClassRules are all applied again. This has the following effect:

  • rowStyle: All new styles are applied. Style properties not present in the new result are not removed — previously applied style properties will persist on the row element.
  • rowClass: All new classes are applied. Old classes are not removed so be aware that classes will accumulate. If you want to remove old classes, then use rowClassRules.
  • rowClassRules: Rules that return true will have the class applied the second time. Rules that return false will have the class removed second time.

Example Row Class Rules Copy Link

The example below demonstrates rowClassRules:

  • rowClassRules are used to apply the class sick-days-warning when the number of sick days > 5 and <= 7, and the class sick-days-breach is applied when the number of sick days >= 8.

  • The grid re-evaluates the rowClassRules and applies styles when the data is changed independent of mechanism. See Updating Data for details on methods to update data.

Highlighting Rows and Columns Copy Link

The grid can highlight both Rows and Columns as the mouse hovers over them.

Highlighting Rows is on by default. To turn it off, set the grid property suppressRowHoverHighlight=true.

Highlighting Columns is off by default. To turn it on, set the grid property columnHoverHighlight=true.

const gridOptions = {
    // turns OFF row hover, it's on by default
    suppressRowHoverHighlight: true,
    // turns ON column hover, it's off by default
    columnHoverHighlight: true,

    // other grid options ...
}

In this example Rows and Columns are highlighted.

Note if you hover over a header group, all columns in the group will be highlighted.

In this example Column highlighting is disabled by default and Row highlighting has been disabled using suppressRowHoverHighlight=true.

Row Highlighting works by the grid adding the CSS class ag-row-hover to the rows getting hovered. The grid cannot depend on using CSS :hover selector as this will not highlight the entire row if Columns are pinned.

Column Highlighting works by the grid adding the CSS class ag-column-hover to all Cells to be highlighted.

Styling the First and Last Rows Copy Link

It's possible to style the first and last rows of the grid using CSS by targeting the .ag-row-first and .ag-row-last selectors as follows:

.ag-row-first {
    background-color: #2244cc44;
}

.ag-row-last {
    background-color: #cc333344;
}

Row customisation can be achieved in the following ways:
- Row Style: Providing a CSS style for the rows. Applied individually to each element.
- Row Class: Providing a CSS class for the rows. Not removed on data refresh.
- Row Class Rules: Providing rules for applying CSS classes. These styles are dynamic and applied in batches.
We recommend Row Class Rules for most use cases. See Refresh of Styles for more details.
When spanning rows, the row is not a visual component, and so the cells should be styled instead.
Each of these approaches are presented in the following sections.
Row Style Copy Link
You can add CSS styles to each row in the following ways:
The style properties to apply to all rows. Set to an object of key (style names) and values (style values). |
Callback version of property rowStyle to set style for each row individually. Function should return an object of CSS values or undefined for no styles. |
// set background colour on every row, this is probably bad, should be using CSS classes
const rowStyle = useMemo(() => {
return { background: 'black' };
}, []);
// set background colour on even rows again, this looks bad, should be using CSS classes
const getRowStyle = useCallback(params => {
if (params.node.rowIndex % 2 === 0) {
return { background: 'red' };
}
}, []);
<AgGridReact
rowStyle={rowStyle}
getRowStyle={getRowStyle}
/>If your data is static, use row classes to apply styles for better performance.
Row Class Copy Link
You can add CSS classes to each row in the following ways:
CSS class(es) for all rows. Provide either a string (class name) or array of strings (array of class names). |
Callback version of property rowClass to set class(es) for each row individually. Function should return either a string (class name), array of strings (array of class names) or undefined for no class. |
// all rows assigned CSS class 'my-green-class'
const rowClass = 'my-green-class';
// all even rows assigned 'my-shaded-effect'
const getRowClass = useCallback(params => {
if (params.node.rowIndex % 2 === 0) {
return 'my-shaded-effect';
}
}, []);
<AgGridReact
rowClass={rowClass}
getRowClass={getRowClass}
/> Row Class Rules Copy Link
You can define rules which can be applied to include certain CSS classes via the grid option rowClassRules. These rules are provided as a map where the keys are class names and the values are expressions that if evaluated to true, the class gets used. The expression can either be a function, or a string which is treated as a shorthand for a function by the grid.
Rules which can be applied to include certain CSS classes. |
The following snippet shows rowClassRules that use functions and the value from the year column:
const rowClassRules = useMemo(() => {
return {
// apply green to 2008
'rag-green-outer': (params) => { return params.data.year === 2008; },
// apply amber 2004
'rag-amber-outer': (params) => { return params.data.year === 2004; },
// apply red to 2000
'rag-red-outer': (params) => { return params.data.year === 2000; }
};
}, []);
<AgGridReact rowClassRules={rowClassRules} /> Row Style/Class Functions Copy Link
All rowStyle, rowClass and rowClassRules functions take a RowClassParams params object.
Properties available on the RowClassParams<TData = any, TContext = any> interface.
The data associated with this row from rowData. Data is undefined for row groups.
|
The RowNode associated with this row |
The index of the row |
The grid api. |
Application context as set on gridOptions.context. |
As an alternative, you can also provide shorthands of the functions using an expression. An expression is evaluated by the grid by executing the string as if it were a Javascript expression. The expression has the following attributes available to it (mapping the attributes of the equivalent params object):
ctx: maps contextnode: maps nodedata: maps datarowIndex: maps rowIndexapi: maps the grid api
The following snippet shows rowClassRules applying classes to rows using expressions on an age column value:
const rowClassRules = useMemo(() => {
return {
'rag-green': 'data.age < 20',
'rag-amber': 'data.age >= 20 && data.age < 25',
'rag-red': 'data.age >= 25',
};
}, []);
<AgGridReact rowClassRules={rowClassRules} /> Refresh of Styles Copy Link
If you refresh a row, or a cell is updated due to editing, the rowStyle, rowClass and rowClassRules are all applied again. This has the following effect:
- rowStyle: All new styles are applied. Style properties not present in the new result are not removed — previously applied style properties will persist on the row element.
- rowClass: All new classes are applied. Old classes are not removed so be aware that classes will accumulate. If you want to remove old classes, then use rowClassRules.
- rowClassRules: Rules that return true will have the class applied the second time. Rules that return false will have the class removed second time.
Example Row Class Rules Copy Link
The example below demonstrates rowClassRules:
rowClassRulesare used to apply the classsick-days-warningwhen the number of sick days > 5 and <= 7, and the classsick-days-breachis applied when the number of sick days >= 8.The grid re-evaluates the rowClassRules and applies styles when the data is changed independent of mechanism. See Updating Data for details on methods to update data.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
NumberEditorModule,
RowApiModule,
RowClassRules,
RowStyleModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [
TextEditorModule,
NumberEditorModule,
RowApiModule,
RowStyleModule,
ClientSideRowModelModule,
];
function randomInt() {
return Math.floor(window.agRandom() * 10);
}
const GridExample = () => {
const gridRef = useRef<AgGridReact>(null);
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [rowData, setRowData] = useState<any[]>(getData());
const [columnDefs, setColumnDefs] = useState<ColDef[]>([
{ headerName: "Employee", field: "employee" },
{ headerName: "Number Sick Days", field: "sickDays", editable: true },
]);
const rowClassRules = useMemo<RowClassRules>(() => {
return {
// row style function
"sick-days-warning": (params) => {
const numSickDays = params.data.sickDays;
return numSickDays > 5 && numSickDays <= 7;
},
// row style expression
"sick-days-breach": "data.sickDays >= 8",
};
}, []);
const setData = useCallback(() => {
gridRef.current!.api.forEachNode(function (rowNode) {
const newData = {
employee: rowNode.data.employee,
sickDays: randomInt(),
};
rowNode.setData(newData);
});
}, []);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div className="example-wrapper">
<div style={{ marginBottom: "5px" }}>
<button onClick={setData}>Update Data</button>
</div>
<div style={gridStyle}>
<AgGridReact
ref={gridRef}
rowData={rowData}
columnDefs={columnDefs}
rowClassRules={rowClassRules}
/>
</div>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.sick-days-warning {
background-color: #cc693344;
}
.sick-days-breach {
background-color: #cc333344;
}
export function getData(): any[] {
return [
{ employee: 'Josh Finch', sickDays: 4 },
{ employee: 'Flavia Mccloskey', sickDays: 1 },
{ employee: 'Marine Creason', sickDays: 8 },
{ employee: 'Carey Livingstone', sickDays: 2 },
{ employee: 'Brande Giorgi', sickDays: 5 },
{ employee: 'Beatrice Kugler', sickDays: 3 },
{ employee: 'Elvia Macko', sickDays: 7 },
{ employee: 'Santiago Little', sickDays: 1 },
{ employee: 'Mary Clifton', sickDays: 2 },
{ employee: 'Norris Iniguez', sickDays: 1 },
{ employee: 'Shellie Umland', sickDays: 5 },
{ employee: 'Kristi Nawrocki', sickDays: 2 },
{ employee: 'Elliot Malo', sickDays: 3 },
{ employee: 'Paul Switzer', sickDays: 11 },
{ employee: 'Lilly Boaz', sickDays: 6 },
{ employee: 'Frank Kimura', sickDays: 1 },
{ employee: 'Alena Wages', sickDays: 5 },
];
}
Highlighting Rows and Columns Copy Link
The grid can highlight both Rows and Columns as the mouse hovers over them.
Highlighting Rows is on by default. To turn it off, set the grid property suppressRowHoverHighlight=true.
Highlighting Columns is off by default. To turn it on, set the grid property columnHoverHighlight=true.
// turns OFF row hover, it's on by default
const suppressRowHoverHighlight = true;
// turns ON column hover, it's off by default
const columnHoverHighlight = true;
<AgGridReact
suppressRowHoverHighlight={suppressRowHoverHighlight}
columnHoverHighlight={columnHoverHighlight}
/>In this example Rows and Columns are highlighted.
Note if you hover over a header group, all columns in the group will be highlighted.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnHoverModule,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ColumnHoverModule, ClientSideRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
columnHoverHighlight={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; In this example Column highlighting is disabled by default and Row highlighting has been disabled using suppressRowHoverHighlight=true.
"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
suppressRowHoverHighlight={true}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
}; Row Highlighting works by the grid adding the CSS class ag-row-hover to the rows getting hovered. The grid cannot depend on using CSS :hover selector as this will not highlight the entire row if Columns are pinned.
Column Highlighting works by the grid adding the CSS class ag-column-hover to all Cells to be highlighted.
Styling the First and Last Rows Copy Link
It's possible to style the first and last rows of the grid using CSS by targeting the .ag-row-first and .ag-row-last selectors as follows:
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}"use client";
import React, {
useCallback,
useMemo,
useRef,
useState,
StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
import { useFetchJson } from "./useFetchJson";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
const modules = [ClientSideRowModelModule];
const GridExample = () => {
const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
const [columnDefs, setColumnDefs] = useState<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
]);
const defaultColDef = useMemo<ColDef>(() => {
return {
flex: 1,
};
}, []);
const { data, loading } = useFetchJson<IOlympicData>(
"https://www.ag-grid.com/example-assets/olympic-winners.json",
5,
);
return (
<AgGridProvider modules={modules}>
<div style={containerStyle}>
<div style={gridStyle}>
<AgGridReact<IOlympicData>
rowData={data}
loading={loading}
columnDefs={columnDefs}
defaultColDef={defaultColDef}
/>
</div>
</div>
</AgGridProvider>
);
};
const root = createRoot(document.getElementById("root")!);
root.render(
<StrictMode>
<GridExample />
</StrictMode>,
);
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} import { useState, useEffect } from 'react';
/**
* Fetch example Json data
* Not recommended for production use!
*/
export const useFetchJson = <T,>(url:string, limit?: number) => {
const [data, setData] = useState<T[]>();
const [loading, setLoading] = useState(true);
useEffect(() => {
// StrictMode runs this effect twice: drop the superseded run's response rather than applying both.
let cancelled = false;
const fetchData = async () => {
setLoading(true);
// Note error handling is omitted here for brevity
const response = await fetch(url);
const json = await response.json();
const data = limit ? json.slice(0, limit) : json;
if (cancelled) {
return;
}
setData(data);
setLoading(false);
};
fetchData();
return () => {
cancelled = true;
};
}, [url, limit]);
return { data, loading };
};

Row customisation can be achieved in the following ways:
- Row Style: Providing a CSS style for the rows. Applied individually to each element.
- Row Class: Providing a CSS class for the rows. Not removed on data refresh.
- Row Class Rules: Providing rules for applying CSS classes. These styles are dynamic and applied in batches.
We recommend Row Class Rules for most use cases. See Refresh of Styles for more details.
When spanning rows, the row is not a visual component, and so the cells should be styled instead.
Each of these approaches are presented in the following sections.
Row Style Copy Link
You can add CSS styles to each row in the following ways:
The style properties to apply to all rows. Set to an object of key (style names) and values (style values). |
Callback version of property rowStyle to set style for each row individually. Function should return an object of CSS values or undefined for no styles. |
<ag-grid-vue
:rowStyle="rowStyle"
:getRowStyle="getRowStyle"
/* other grid options ... */>
</ag-grid-vue>
// set background colour on every row, this is probably bad, should be using CSS classes
this.rowStyle = { background: 'black' };
// set background colour on even rows again, this looks bad, should be using CSS classes
this.getRowStyle = params => {
if (params.node.rowIndex % 2 === 0) {
return { background: 'red' };
}
};If your data is static, use row classes to apply styles for better performance.
Row Class Copy Link
You can add CSS classes to each row in the following ways:
CSS class(es) for all rows. Provide either a string (class name) or array of strings (array of class names). |
Callback version of property rowClass to set class(es) for each row individually. Function should return either a string (class name), array of strings (array of class names) or undefined for no class. |
<ag-grid-vue
:rowClass="rowClass"
:getRowClass="getRowClass"
/* other grid options ... */>
</ag-grid-vue>
// all rows assigned CSS class 'my-green-class'
this.rowClass = 'my-green-class';
// all even rows assigned 'my-shaded-effect'
this.getRowClass = params => {
if (params.node.rowIndex % 2 === 0) {
return 'my-shaded-effect';
}
}; Row Class Rules Copy Link
You can define rules which can be applied to include certain CSS classes via the grid option rowClassRules. These rules are provided as a map where the keys are class names and the values are expressions that if evaluated to true, the class gets used. The expression can either be a function, or a string which is treated as a shorthand for a function by the grid.
Rules which can be applied to include certain CSS classes. |
The following snippet shows rowClassRules that use functions and the value from the year column:
<ag-grid-vue
:rowClassRules="rowClassRules"
/* other grid options ... */>
</ag-grid-vue>
this.rowClassRules = {
// apply green to 2008
'rag-green-outer': (params) => { return params.data.year === 2008; },
// apply amber 2004
'rag-amber-outer': (params) => { return params.data.year === 2004; },
// apply red to 2000
'rag-red-outer': (params) => { return params.data.year === 2000; }
}; Row Style/Class Functions Copy Link
All rowStyle, rowClass and rowClassRules functions take a RowClassParams params object.
Properties available on the RowClassParams<TData = any, TContext = any> interface.
The data associated with this row from rowData. Data is undefined for row groups.
|
The RowNode associated with this row |
The index of the row |
The grid api. |
Application context as set on gridOptions.context. |
As an alternative, you can also provide shorthands of the functions using an expression. An expression is evaluated by the grid by executing the string as if it were a Javascript expression. The expression has the following attributes available to it (mapping the attributes of the equivalent params object):
ctx: maps contextnode: maps nodedata: maps datarowIndex: maps rowIndexapi: maps the grid api
The following snippet shows rowClassRules applying classes to rows using expressions on an age column value:
<ag-grid-vue
:rowClassRules="rowClassRules"
/* other grid options ... */>
</ag-grid-vue>
this.rowClassRules = {
'rag-green': 'data.age < 20',
'rag-amber': 'data.age >= 20 && data.age < 25',
'rag-red': 'data.age >= 25',
}; Refresh of Styles Copy Link
If you refresh a row, or a cell is updated due to editing, the rowStyle, rowClass and rowClassRules are all applied again. This has the following effect:
- rowStyle: All new styles are applied. Style properties not present in the new result are not removed — previously applied style properties will persist on the row element.
- rowClass: All new classes are applied. Old classes are not removed so be aware that classes will accumulate. If you want to remove old classes, then use rowClassRules.
- rowClassRules: Rules that return true will have the class applied the second time. Rules that return false will have the class removed second time.
Example Row Class Rules Copy Link
The example below demonstrates rowClassRules:
rowClassRulesare used to apply the classsick-days-warningwhen the number of sick days > 5 and <= 7, and the classsick-days-breachis applied when the number of sick days >= 8.The grid re-evaluates the rowClassRules and applies styles when the data is changed independent of mechanism. See Updating Data for details on methods to update data.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowApiModule,
RowClassRules,
RowStyleModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
NumberEditorModule,
RowApiModule,
RowStyleModule,
ClientSideRowModelModule,
]);
function randomInt() {
return Math.floor(window.agRandom() * 10);
}
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<div class="example-wrapper">
<div style="margin-bottom: 5px">
<button v-on:click="setData()">Update Data</button>
</div>
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:rowData="rowData"
:columnDefs="columnDefs"
:rowClassRules="rowClassRules"></ag-grid-vue>
</div>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi | null>(null);
const rowData = ref<any[] | null>(getData());
const columnDefs = ref<ColDef[]>([
{ headerName: "Employee", field: "employee" },
{ headerName: "Number Sick Days", field: "sickDays", editable: true },
]);
const rowClassRules = ref<RowClassRules>({
// row style function
"sick-days-warning": (params) => {
const numSickDays = params.data.sickDays;
return numSickDays > 5 && numSickDays <= 7;
},
// row style expression
"sick-days-breach": "data.sickDays >= 8",
});
function setData() {
gridApi.value!.forEachNode(function (rowNode) {
const newData = {
employee: rowNode.data.employee,
sickDays: randomInt(),
};
rowNode.setData(newData);
});
}
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
};
return {
gridApi,
rowData,
columnDefs,
rowClassRules,
onGridReady,
setData,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.sick-days-warning {
background-color: #cc693344;
}
.sick-days-breach {
background-color: #cc333344;
}
export function getData(): any[] {
return [
{ employee: 'Josh Finch', sickDays: 4 },
{ employee: 'Flavia Mccloskey', sickDays: 1 },
{ employee: 'Marine Creason', sickDays: 8 },
{ employee: 'Carey Livingstone', sickDays: 2 },
{ employee: 'Brande Giorgi', sickDays: 5 },
{ employee: 'Beatrice Kugler', sickDays: 3 },
{ employee: 'Elvia Macko', sickDays: 7 },
{ employee: 'Santiago Little', sickDays: 1 },
{ employee: 'Mary Clifton', sickDays: 2 },
{ employee: 'Norris Iniguez', sickDays: 1 },
{ employee: 'Shellie Umland', sickDays: 5 },
{ employee: 'Kristi Nawrocki', sickDays: 2 },
{ employee: 'Elliot Malo', sickDays: 3 },
{ employee: 'Paul Switzer', sickDays: 11 },
{ employee: 'Lilly Boaz', sickDays: 6 },
{ employee: 'Frank Kimura', sickDays: 1 },
{ employee: 'Alena Wages', sickDays: 5 },
];
}
Highlighting Rows and Columns Copy Link
The grid can highlight both Rows and Columns as the mouse hovers over them.
Highlighting Rows is on by default. To turn it off, set the grid property suppressRowHoverHighlight=true.
Highlighting Columns is off by default. To turn it on, set the grid property columnHoverHighlight=true.
<ag-grid-vue
:suppressRowHoverHighlight="suppressRowHoverHighlight"
:columnHoverHighlight="columnHoverHighlight"
/* other grid options ... */>
</ag-grid-vue>
// turns OFF row hover, it's on by default
this.suppressRowHoverHighlight = true;
// turns ON column hover, it's off by default
this.columnHoverHighlight = true;In this example Rows and Columns are highlighted.
Note if you hover over a header group, all columns in the group will be highlighted.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnHoverModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ColumnHoverModule, ClientSideRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:columnHoverHighlight="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
In this example Column highlighting is disabled by default and Row highlighting has been disabled using suppressRowHoverHighlight=true.
import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:suppressRowHoverHighlight="true"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data);
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
Row Highlighting works by the grid adding the CSS class ag-row-hover to the rows getting hovered. The grid cannot depend on using CSS :hover selector as this will not highlight the entire row if Columns are pinned.
Column Highlighting works by the grid adding the CSS class ag-column-hover to all Cells to be highlighted.
Styling the First and Last Rows Copy Link
It's possible to style the first and last rows of the grid using CSS by targeting the .ag-row-first and .ag-row-last selectors as follows:
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}import {
createApp,
defineComponent,
onBeforeMount,
ref,
shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
import { IOlympicData } from "./interfaces";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
const VueExample = defineComponent({
template: `
<div style="height: 100%">
<ag-grid-vue
style="width: 100%; height: 100%;"
@grid-ready="onGridReady"
:columnDefs="columnDefs"
:defaultColDef="defaultColDef"
:rowData="rowData"></ag-grid-vue>
</div>
`,
components: {
"ag-grid-vue": AgGridVue,
},
setup(props) {
const gridApi = shallowRef<GridApi<IOlympicData> | null>(null);
const columnDefs = ref<(ColDef | ColGroupDef)[]>([
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
]);
const defaultColDef = ref<ColDef>({
flex: 1,
});
const rowData = ref<IOlympicData[]>(null);
const onGridReady = (params: GridReadyEvent) => {
gridApi.value = params.api;
const updateData = (data) => (rowData.value = data.slice(0, 5));
fetch("https://www.ag-grid.com/example-assets/olympic-winners.json")
.then((resp) => resp.json())
.then((data) => updateData(data));
};
return {
gridApi,
columnDefs,
defaultColDef,
rowData,
onGridReady,
};
},
});
const app = createApp(VueExample);
app.mount("#app");
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}

Row customisation can be achieved in the following ways:
- Row Style: Providing a CSS style for the rows. Applied individually to each element.
- Row Class: Providing a CSS class for the rows. Not removed on data refresh.
- Row Class Rules: Providing rules for applying CSS classes. These styles are dynamic and applied in batches.
We recommend Row Class Rules for most use cases. See Refresh of Styles for more details.
When spanning rows, the row is not a visual component, and so the cells should be styled instead.
Each of these approaches are presented in the following sections.
Row Style Copy Link
You can add CSS styles to each row in the following ways:
The style properties to apply to all rows. Set to an object of key (style names) and values (style values). |
Callback version of property rowStyle to set style for each row individually. Function should return an object of CSS values or undefined for no styles. |
<ag-grid-angular
[rowStyle]="rowStyle"
[getRowStyle]="getRowStyle"
/* other grid options ... */ />
// set background colour on every row, this is probably bad, should be using CSS classes
this.rowStyle = { background: 'black' };
// set background colour on even rows again, this looks bad, should be using CSS classes
this.getRowStyle = params => {
if (params.node.rowIndex % 2 === 0) {
return { background: 'red' };
}
};If your data is static, use row classes to apply styles for better performance.
Row Class Copy Link
You can add CSS classes to each row in the following ways:
CSS class(es) for all rows. Provide either a string (class name) or array of strings (array of class names). |
Callback version of property rowClass to set class(es) for each row individually. Function should return either a string (class name), array of strings (array of class names) or undefined for no class. |
<ag-grid-angular
[rowClass]="rowClass"
[getRowClass]="getRowClass"
/* other grid options ... */ />
// all rows assigned CSS class 'my-green-class'
this.rowClass = 'my-green-class';
// all even rows assigned 'my-shaded-effect'
this.getRowClass = params => {
if (params.node.rowIndex % 2 === 0) {
return 'my-shaded-effect';
}
}; Row Class Rules Copy Link
You can define rules which can be applied to include certain CSS classes via the grid option rowClassRules. These rules are provided as a map where the keys are class names and the values are expressions that if evaluated to true, the class gets used. The expression can either be a function, or a string which is treated as a shorthand for a function by the grid.
Rules which can be applied to include certain CSS classes. |
The following snippet shows rowClassRules that use functions and the value from the year column:
<ag-grid-angular
[rowClassRules]="rowClassRules"
/* other grid options ... */ />
this.rowClassRules = {
// apply green to 2008
'rag-green-outer': (params) => { return params.data.year === 2008; },
// apply amber 2004
'rag-amber-outer': (params) => { return params.data.year === 2004; },
// apply red to 2000
'rag-red-outer': (params) => { return params.data.year === 2000; }
}; Row Style/Class Functions Copy Link
All rowStyle, rowClass and rowClassRules functions take a RowClassParams params object.
Properties available on the RowClassParams<TData = any, TContext = any> interface.
The data associated with this row from rowData. Data is undefined for row groups.
|
The RowNode associated with this row |
The index of the row |
The grid api. |
Application context as set on gridOptions.context. |
As an alternative, you can also provide shorthands of the functions using an expression. An expression is evaluated by the grid by executing the string as if it were a Javascript expression. The expression has the following attributes available to it (mapping the attributes of the equivalent params object):
ctx: maps contextnode: maps nodedata: maps datarowIndex: maps rowIndexapi: maps the grid api
The following snippet shows rowClassRules applying classes to rows using expressions on an age column value:
<ag-grid-angular
[rowClassRules]="rowClassRules"
/* other grid options ... */ />
this.rowClassRules = {
'rag-green': 'data.age < 20',
'rag-amber': 'data.age >= 20 && data.age < 25',
'rag-red': 'data.age >= 25',
}; Refresh of Styles Copy Link
If you refresh a row, or a cell is updated due to editing, the rowStyle, rowClass and rowClassRules are all applied again. This has the following effect:
- rowStyle: All new styles are applied. Style properties not present in the new result are not removed — previously applied style properties will persist on the row element.
- rowClass: All new classes are applied. Old classes are not removed so be aware that classes will accumulate. If you want to remove old classes, then use rowClassRules.
- rowClassRules: Rules that return true will have the class applied the second time. Rules that return false will have the class removed second time.
Example Row Class Rules Copy Link
The example below demonstrates rowClassRules:
rowClassRulesare used to apply the classsick-days-warningwhen the number of sick days > 5 and <= 7, and the classsick-days-breachis applied when the number of sick days >= 8.The grid re-evaluates the rowClassRules and applies styles when the data is changed independent of mechanism. See Updating Data for details on methods to update data.
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
NumberEditorModule,
RowApiModule,
RowClassRules,
RowStyleModule,
TextEditorModule,
enableDevValidations,
} from "ag-grid-community";
import { getData } from "./data";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([
TextEditorModule,
NumberEditorModule,
RowApiModule,
RowStyleModule,
ClientSideRowModelModule,
]);
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<div class="example-wrapper">
<div style="margin-bottom: 5px">
<button (click)="setData()">Update Data</button>
</div>
<ag-grid-angular
style="width: 100%; height: 100%;"
[rowData]="rowData"
[columnDefs]="columnDefs"
[rowClassRules]="rowClassRules"
(gridReady)="onGridReady($event)"
/>
</div> `,
})
export class AppComponent {
private gridApi!: GridApi;
rowData: any[] | null = getData();
columnDefs: ColDef[] = [
{ headerName: "Employee", field: "employee" },
{ headerName: "Number Sick Days", field: "sickDays", editable: true },
];
rowClassRules: RowClassRules = {
// row style function
"sick-days-warning": (params) => {
const numSickDays = params.data.sickDays;
return numSickDays > 5 && numSickDays <= 7;
},
// row style expression
"sick-days-breach": "data.sickDays >= 8",
};
setData() {
this.gridApi.forEachNode(function (rowNode) {
const newData = {
employee: rowNode.data.employee,
sickDays: randomInt(),
};
rowNode.setData(newData);
});
}
onGridReady(params: GridReadyEvent) {
this.gridApi = params.api;
}
}
function randomInt() {
return Math.floor(window.agRandom() * 10);
}
.example-wrapper {
display: flex;
flex-direction: column;
height: 100%;
}
#myGrid {
flex: 1 1 0px;
width: 100%;
}
.sick-days-warning {
background-color: #cc693344;
}
.sick-days-breach {
background-color: #cc333344;
}
export function getData(): any[] {
return [
{ employee: 'Josh Finch', sickDays: 4 },
{ employee: 'Flavia Mccloskey', sickDays: 1 },
{ employee: 'Marine Creason', sickDays: 8 },
{ employee: 'Carey Livingstone', sickDays: 2 },
{ employee: 'Brande Giorgi', sickDays: 5 },
{ employee: 'Beatrice Kugler', sickDays: 3 },
{ employee: 'Elvia Macko', sickDays: 7 },
{ employee: 'Santiago Little', sickDays: 1 },
{ employee: 'Mary Clifton', sickDays: 2 },
{ employee: 'Norris Iniguez', sickDays: 1 },
{ employee: 'Shellie Umland', sickDays: 5 },
{ employee: 'Kristi Nawrocki', sickDays: 2 },
{ employee: 'Elliot Malo', sickDays: 3 },
{ employee: 'Paul Switzer', sickDays: 11 },
{ employee: 'Lilly Boaz', sickDays: 6 },
{ employee: 'Frank Kimura', sickDays: 1 },
{ employee: 'Alena Wages', sickDays: 5 },
];
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
Highlighting Rows and Columns Copy Link
The grid can highlight both Rows and Columns as the mouse hovers over them.
Highlighting Rows is on by default. To turn it off, set the grid property suppressRowHoverHighlight=true.
Highlighting Columns is off by default. To turn it on, set the grid property columnHoverHighlight=true.
<ag-grid-angular
[suppressRowHoverHighlight]="suppressRowHoverHighlight"
[columnHoverHighlight]="columnHoverHighlight"
/* other grid options ... */ />
// turns OFF row hover, it's on by default
this.suppressRowHoverHighlight = true;
// turns ON column hover, it's off by default
this.columnHoverHighlight = true;In this example Rows and Columns are highlighted.
Note if you hover over a header group, all columns in the group will be highlighted.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
ColumnHoverModule,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ColumnHoverModule, ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[columnHoverHighlight]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} In this example Column highlighting is disabled by default and Row highlighting has been disabled using suppressRowHoverHighlight=true.
import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[suppressRowHoverHighlight]="true"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data));
}
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
} Row Highlighting works by the grid adding the CSS class ag-row-hover to the rows getting hovered. The grid cannot depend on using CSS :hover selector as this will not highlight the entire row if Columns are pinned.
Column Highlighting works by the grid adding the CSS class ag-column-hover to all Cells to be highlighted.
Styling the First and Last Rows Copy Link
It's possible to style the first and last rows of the grid using CSS by targeting the .ag-row-first and .ag-row-last selectors as follows:
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}import { Component } from "@angular/core";
import { HttpClient } from "@angular/common/http";
import { AgGridAngular } from "ag-grid-angular";
import "./styles.css";
import {
ClientSideRowModelModule,
ColDef,
ColGroupDef,
GridApi,
GridOptions,
GridReadyEvent,
ModuleRegistry,
enableDevValidations,
} from "ag-grid-community";
if (process.env.NODE_ENV !== "production") {
// Enable extended validations only for development
enableDevValidations();
}
ModuleRegistry.registerModules([ClientSideRowModelModule]);
import { IOlympicData } from "./interfaces";
@Component({
selector: "my-app",
standalone: true,
imports: [AgGridAngular],
template: `<ag-grid-angular
style="width: 100%; height: 100%;"
[columnDefs]="columnDefs"
[defaultColDef]="defaultColDef"
[rowData]="rowData"
(gridReady)="onGridReady($event)"
/> `,
})
export class AppComponent {
columnDefs: (ColDef | ColGroupDef)[] = [
{
headerName: "Participant",
children: [{ field: "athlete" }, { field: "age" }],
},
{
headerName: "Details",
children: [
{ field: "country" },
{ field: "year" },
{ field: "date" },
{ field: "sport" },
],
},
{
headerName: "Medals",
children: [
{ field: "gold" },
{ field: "silver" },
{ field: "bronze" },
{ field: "total" },
],
},
];
defaultColDef: ColDef = {
flex: 1,
};
rowData!: IOlympicData[];
constructor(private http: HttpClient) {}
onGridReady(params: GridReadyEvent<IOlympicData>) {
this.http
.get<
IOlympicData[]
>("https://www.ag-grid.com/example-assets/olympic-winners.json")
.subscribe((data) => (this.rowData = data.slice(0, 5)));
}
}
.ag-row-first {
background-color: #2244cc44;
}
.ag-row-last {
background-color: #cc333344;
}
import '@angular/compiler';
import { provideHttpClient } from '@angular/common/http';
import { enableProdMode } from '@angular/core';
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
if (new URLSearchParams(window.location.search).get('prod') !== 'false') {
enableProdMode();
}
const app = bootstrapApplication(AppComponent, {
providers: [provideHttpClient()],
});
export interface IOlympicData {
athlete: string,
age: number,
country: string,
year: number,
date: string,
sport: string,
gold: number,
silver: number,
bronze: number,
total: number
}